//#include <SoftwareSerial.h>
#include <Servo.h>
#include <DFRobot_ID809.h>

//#define FPSerial Serial1
#define FPSerial Serial
#define LED 13
#define Button 12
#define Servo_port 9
#define SafeOpen 90
#define SefeClose 0
#define COLLECT_NUMBER 3

//SoftwareSerial Serial1(2, 3);
Servo servo;
DFRobot_ID809 fingerprint;
bool IsSafeClosed = true;

void enroll()
{
  int i = 0;
  int ID = fingerprint.getEmptyID();
  if (ID == ERR_ID809)
  {
    digitalWrite(LED, HIGH);
    while (1);
  }
  while (i < COLLECT_NUMBER)
  {
    fingerprint.ctrlLED(fingerprint.eFastBlink, fingerprint.eLEDMagenta, 0);
    if ((fingerprint.collectionFingerprint(10)) != ERR_ID809)
    {
      fingerprint.ctrlLED(fingerprint.eSlowBlink, fingerprint.eLEDYellow, 0);
      i++;
    }
    while (fingerprint.detectFinger());
  }
  if (fingerprint.storeFingerprint(ID) != ERR_ID809)
  {
    fingerprint.ctrlLED(fingerprint.eKeepsOn, fingerprint.eLEDGreen, 0);
    delay(1000);
    fingerprint.ctrlLED(fingerprint.eNormalClose, fingerprint.eLEDBlue, 0);
    delay(1000);
  }
}

void Delete()
{
  int ret;
  fingerprint.ctrlLED(fingerprint.eBreathing, fingerprint.eLEDRed, 0);
  if ((fingerprint.collectionFingerprint(0)) != ERR_ID809)
  {
    fingerprint.ctrlLED(fingerprint.eFastBlink, fingerprint.eLEDYellow, 3);
    while (fingerprint.detectFinger());
    ret = fingerprint.search();
    if (ret != 0)
    {
      fingerprint.delFingerprint(ret);
      fingerprint.ctrlLED(fingerprint.eKeepsOn, fingerprint.eLEDGreen, 0);
    } else
      fingerprint.ctrlLED(fingerprint.eKeepsOn, fingerprint.eLEDRed, 0);
  }
}

void setup() {
  pinMode(LED, OUTPUT);
  pinMode(Button, INPUT_PULLUP);
  digitalWrite(LED, LOW);
  servo.attach(Servo_port);
  servo.write(SefeClose);
  FPSerial.begin(9600);
  fingerprint.begin(FPSerial);
  if (fingerprint.isConnected() == false)
    digitalWrite(LED, HIGH);
}

void loop() {
  int ret;
  fingerprint.ctrlLED(fingerprint.eBreathing, fingerprint.eLEDBlue, 0);
  if ((fingerprint.collectionFingerprint(0)) != ERR_ID809)
  {
    fingerprint.ctrlLED(fingerprint.eFastBlink, fingerprint.eLEDYellow, 3);
    while (fingerprint.detectFinger());
    ret = fingerprint.search();
    if (ret != 0)
    {
      if (digitalRead(Button) == 0)
        enroll();
      else
      {
        fingerprint.ctrlLED(fingerprint.eKeepsOn, fingerprint.eLEDGreen, 0);

        if (IsSafeClosed == true)
          servo.write(90);
        else
          servo.write(0);

        IsSafeClosed = !IsSafeClosed;
      }

    } else
    {
      if (digitalRead(Button) == 0)
        Delete();
      else
        fingerprint.ctrlLED(fingerprint.eKeepsOn, fingerprint.eLEDRed, 0);

    }
  }

  delay(1000);
}
